/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.tables.TCoreElementHierarchy;

import java.time.LocalDateTime;

import org.jooq.JSONB;
import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementHierarchyRecord extends UpdatableRecordImpl<TCoreElementHierarchyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.key_element</code>.
     * unique element id
     */
    public void setKeyElement(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.key_element</code>.
     * unique element id
     */
    public Integer getKeyElement() {
        return (Integer) get(0);
    }

    /**
     * Setter for
     * <code>common_dd.t_core_element_hierarchy.key_element_type</code>.
     * reference to element type
     */
    public void setKeyElementType(Integer value) {
        set(1, value);
    }

    /**
     * Getter for
     * <code>common_dd.t_core_element_hierarchy.key_element_type</code>.
     * reference to element type
     */
    public Integer getKeyElementType() {
        return (Integer) get(1);
    }

    /**
     * Setter for
     * <code>common_dd.t_core_element_hierarchy.key_parent_element</code>.
     * reference to element id of parent element
     */
    public void setKeyParentElement(Integer value) {
        set(2, value);
    }

    /**
     * Getter for
     * <code>common_dd.t_core_element_hierarchy.key_parent_element</code>.
     * reference to element id of parent element
     */
    public Integer getKeyParentElement() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.dn</code>. birth name
     * of this element
     */
    public void setDn(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.dn</code>. birth name
     * of this element
     */
    public String getDn() {
        return (String) get(3);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.order_nr</code>.
     * order number
     */
    public void setOrderNr(Integer value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.order_nr</code>.
     * order number
     */
    public Integer getOrderNr() {
        return (Integer) get(4);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.short_name</code>.
     * short name
     */
    public void setShortName(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.short_name</code>.
     * short name
     */
    public String getShortName() {
        return (String) get(5);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.is_public</code>. is
     * public? 1 = yes, 0 = no
     */
    public void setIsPublic(Integer value) {
        set(6, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.is_public</code>. is
     * public? 1 = yes, 0 = no
     */
    public Integer getIsPublic() {
        return (Integer) get(6);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.hier_lang</code>.
     * reference to language key
     */
    public void setHierLang(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.hier_lang</code>.
     * reference to language key
     */
    public String getHierLang() {
        return (String) get(7);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.stage</code>. stage
     * of element; see T_CORE_STAGE for details
     */
    public void setStage(Integer value) {
        set(8, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.stage</code>. stage
     * of element; see T_CORE_STAGE for details
     */
    public Integer getStage() {
        return (Integer) get(8);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(9, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(9);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.fk_right_id</code>.
     */
    public void setFkRightId(Integer value) {
        set(10, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.fk_right_id</code>.
     */
    public Integer getFkRightId() {
        return (Integer) get(10);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.fk_privilege</code>.
     */
    public void setFkPrivilege(Integer value) {
        set(11, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.fk_privilege</code>.
     */
    public Integer getFkPrivilege() {
        return (Integer) get(11);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.origin</code>.
     */
    public void setOrigin(JSONB value) {
        set(12, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.origin</code>.
     */
    public JSONB getOrigin() {
        return (JSONB) get(12);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.unique_name</code>.
     */
    public void setUniqueName(String value) {
        set(13, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.unique_name</code>.
     */
    public String getUniqueName() {
        return (String) get(13);
    }

    /**
     * Setter for <code>common_dd.t_core_element_hierarchy.prefix_short</code>.
     */
    public void setPrefixShort(String value) {
        set(14, value);
    }

    /**
     * Getter for <code>common_dd.t_core_element_hierarchy.prefix_short</code>.
     */
    public String getPrefixShort() {
        return (String) get(14);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TCoreElementHierarchyRecord
     */
    public TCoreElementHierarchyRecord() {
        super(TCoreElementHierarchy.T_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * Create a detached, initialised TCoreElementHierarchyRecord
     */
    public TCoreElementHierarchyRecord(Integer keyElement, Integer keyElementType, Integer keyParentElement, String dn, Integer orderNr, String shortName, Integer isPublic, String hierLang, Integer stage, LocalDateTime lastchange, Integer fkRightId, Integer fkPrivilege, JSONB origin, String uniqueName, String prefixShort) {
        super(TCoreElementHierarchy.T_CORE_ELEMENT_HIERARCHY);

        setKeyElement(keyElement);
        setKeyElementType(keyElementType);
        setKeyParentElement(keyParentElement);
        setDn(dn);
        setOrderNr(orderNr);
        setShortName(shortName);
        setIsPublic(isPublic);
        setHierLang(hierLang);
        setStage(stage);
        setLastchange(lastchange);
        setFkRightId(fkRightId);
        setFkPrivilege(fkPrivilege);
        setOrigin(origin);
        setUniqueName(uniqueName);
        setPrefixShort(prefixShort);
        resetChangedOnNotNull();
    }
}
